#### connect (2 of 8 overloads)

Establishes a socket connection by trying each endpoint in a sequence.

    template<
        typename Protocol,
        typename Executor,
        typename EndpointSequence>
    Protocol::endpoint connect(
        basic_socket< Protocol, Executor > & s,
        const EndpointSequence & endpoints,
        asio::error_code & ec,
        constraint_t< is_endpoint_sequence< EndpointSequence >::value >  = 0);

This function attempts to connect a socket to one of a sequence of endpoints. It does this by repeated calls to the socket's `connect` member function, once for each endpoint in the sequence, until a connection is successfully established.

###### Parameters

s

  The socket to be connected. If the socket is already open, it will be closed.

endpoints

  A sequence of endpoints.

ec

  Set to indicate what error occurred, if any. If the sequence is empty, set to `asio::error::not_found`. Otherwise, contains the error from the last connection attempt.

###### Return Value

On success, the successfully connected endpoint. Otherwise, a default-constructed endpoint.

###### Example

    tcp::resolver r(my_context);
    tcp::resolver::query q("host", "service");
    tcp::socket s(my_context);
    asio::error_code ec;
    asio::connect(s, r.resolve(q), ec);
    if (ec)
    {
      // An error occurred.
    }